Ruby - Bug #4072

dRubyl 0000000000000 sleepi0000exitio0n0n0n
11/19/2010 05:50 PM - takkanm (00 00)

Status: Closed

Priority: Normal

Assignee: matz (Yukihiro Matsumoto)

Target version: 1.9.2

ruby -v: - Backport:
Description

=begin

ruby 1.9.2p0 (2010-08-18 revision 29036) [x86_64-darwin10.4.0]0010
dRubyl000000serverlclientl00server->clientd000000
server1000000000000exitD00D

ruby 1.9.3dev (2010-11-19 trunk 29830) [x86_64-darwin10.5.0]00000000000

ruby 1.8.7 (2010-08-16 patchlevel 302) [i686-darwin10.4.0]000
ex.tDDDDDDDDDDDDDDDD

https://gist.github.com/706260

o server]0000

require 'drb’

class Hello

def hello(message)
puts message

end

end

begin

DRb.start_service('druby://:12346', Hello.new)
puts DRb.uri

sleep

rescue Object, SystemExit=> e

p e.backtrace

raise e

rescue => e

puts e

end

o clientD0000
require 'drb’
d = DRbObject.new_with_uri('druby://m-mimura-4.local:12346")
d.hello "message”
=end

Related issues:
Related to Ruby - Bug #4027: Signal.trap I busy loop 000

Rejected

05/23/2011

Associated revisions

Revision 1a196574 - 06/25/2011 02:21 PM - nagachika (Tomoyuki Chikanaga)

¢ thread.c (rb_threadptr_check_signal): remove unnecessary th->status
backup. fix race condition which may results unexpected main thread's
status transition. see #4072

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@32225 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision fb72e453 - 06/25/2011 02:28 PM - nagachika (Tomoyuki Chikanaga)
https://gist.github.com/706260

e thread.c (sleep_forever): now Kernel#sleep don't wakeup by
signal handler execution. [Bug #4072]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@32226 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 11/19/2010 06:11 PM - takkanm (00 00)

=begin
0000000000000000000000onnonDO
000000000000000000000000000000nan0g

=end
#2 - 11/20/2010 05:19 AM - ujihisa (Tatsuhiro Ujihisa)

=begin
00ooo0o0ooooonoonoooooonoonnooOoOnnonnDoOOOnnonnOOO00n00nDOOO0000nnDOOO0nD

/Users/ujihisa/git/ruby192/local/lib/ruby/1.9.1/drb/drb.rb:736:in rescue in block in open': druby://localhost: 12346 - #<Errno::ECONNREFUSED:
Connection refused - connect(2)> (DRb::DRbConnError) from /Users/ujihisa/git/ruby192/local/lib/ruby/1.9.1/drb/drb.rb:730:in block in open’

from /Users/ujihisa/git/ruby192/local/lib/ruby/1.9.1/drb/drb.rb:729:in each' from /Users/ujihisa/git/ruby192/local/lib/ruby/1.9.1/drb/drb.rb:729:in open'
from /Users/ujihisa/git/ruby192/local/lib/ruby/1.9.1/drb/drb.rb:1191:in initialize' from /Users/ujihisa/git/ruby192/local/lib/ruby/1.9.1/drb/drb.rb:1171:in
new'

from /Users/ujihisa/git/ruby192/local/lib/ruby/1.9.1/drb/drb.rb:1171:in open' from /Users/ujihisa/git/ruby192/local/lib/ruby/1.9.1/drb/drb.rb:1087:in block
in method_missing'

from /Users/ujihisa/git/ruby192/local/lib/ruby/1.9.1/drb/drb.rb:1105:in with_friend' from /Users/ujihisa/git/ruby192/local/lib/ruby/1.9.1/drb/drb.rb:1086:in
method_missing'

from c.rb:4:in ™'

000000000rubyl ruby 1.9.2p14 (2010-10-02 revision 29393) [x86_64-darwin10.4.1] 000
=end

#3 - 11/20/2010 10:21 AM - takkanm (00 01)

=begin
0oooo
2010011020007:37 Masatoshi SEKI m_seki@mva.biglobe.ne.jp:

0000000

00000000000000DRb.urilputs00000000 > 0000
00000000nenod00O00000D0DODODODO0OO0O0DODsIeepl
00obonopopooooo

sleepl00000000000000000000000000DO0DOO0D
00o0bopooboooonooo.

=end

#4 - 11/21/2010 12:13 AM - nagachika (Tomoyuki Chikanaga)

=begin

[I[I[I[I[I[I[I[I

trunk 0000000000000000000000000

000 #4027 000000000000000O000DOOODDOOODDOOOODODO0O
000000000000000000000

ruby -v [I ruby 1.9.3dev (2010-11-19 trunk 29831) [x86_64-darwin10.5.0] 000

message (0000000 00000000 sleep 00000000000000
(10000000000000000000 message 0000000000000
aa sleep nooon DRb.thread.join noooooooooo

ruby [I -o 0000000000000000000DRbMessagettsend_reply [ Erroz:EPIPE [I

00000000 sleep OOO0OOOOODO0O

0000 sicpiPe D00000000(sigpipe) O0000000000000000000
pthread_cond_wait 10000=0 ermo=EINTR 00000000

DDUDDDDDUUDDDDDUUDDDDDUUDDDDDUUDDDDDUDD

000000000000000000 message 00000 sicINT 0 sicTERM 000000000
00000o0oobonoononooo

=end

#5 - 06/23/2011 11:28 PM - nagachika (Tomoyuki Chikanaga)
mailto:m_seki@mva.biglobe.ne.jp
https://bugs.ruby-lang.org/issues/4027

- Category set to core

- Status changed from Open to Closed

000000000 r31482 00000 native_cond_wait() 0 EINTR 000000000000000
00000000000000000

(0000 ruby 1.9.2dev (2010-05-10 revision 27709) 000000000 trunk 00000000000000
ruby_1_9_2 (000000000 1.9.2-head 00000000000000000000)0

000000closel000DO0DOO0DO0DO0DOOreopendlOOOODD

#6 - 06/24/2011 12:33 PM - kosaki (Motohiro KOSAKI)
00Maclpthread_cond_wait() 00000000

http://www.opensource.apple.com/source/Libc/Libc-594.9.4/pthreads/pthread cond.c

/*

e Suspend waiting for a condition variable.
¢ Note: we have to keep a list of condition variables which are using
¢ this same mutex variable so we can detect invalid 'destroy' sequences.
e If isconforming < 0, we skip the _pthread_testcancel(), but keep the
¢ remaining conforming behavior..

*/

private_extern int

_pthread_cond_wait(pthread_cond_t *cond,

pthread_mutex_t *mutex,

const struct timespec abstime,

int isRelative,

int isconforming)

{

(snip)

}else {

if (wait_res < 0) {

if (errno == ETIMEDOUT) {

return ETIMEDOUT;
} else if (errno == EINTR) {
/

** EINTR can be treated as a spurious wakeup unless we were canceled.
*/
return 0;

}
return EINVAL;

}

return O;
}
}

00000000eNTRO0DODODODOOOO00DEINTROODODODO0000000000000
000sleepl00000sleep_timeval()l1.9.20000000000000000000000000000000
HHHHHHHHHDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD

000000oDoDoooonoDoDoDODoDaDo0nOnang

#7 - 06/24/2011 01:28 PM - nagachika (Tomoyuki Chikanaga)
000000eNnTR 00000DDDOOD sicrPiPE O siG_prFL 00000000000000000

#8 - 06/24/2011 01:53 PM - nagachika (Tomoyuki Chikanaga)
000000000siG_pFL 00000 siG_1gN 0000
1000000 sleep 0000 sleep_forever() 00000000000 deadlockable 000 o 00 while 00000000000000000000000000000000000D0000000O0DDO

#9 - 06/24/2011 09:00 PM - nagachika (Tomoyuki Chikanaga)
- Status changed from Closed to Open

0000000000000000 open 0OOO
kosaki 00000000000000 kernel#sleep 10000000000000000000000000000 trunk 000000000000000O00000D sleep 000 darwint0.7.0 00
SIGINT [ sleep 0000000000000

Signal.trap(:INT){}
http://www.opensource.apple.com/source/Libc/Libc-594.9.4/pthreads/pthread_cond.c

sleep

000 spurious wakeup 000000000000000000000000000C0D
while 1000000000000000000000000000RuBY_VM_CHECK_INTS() D00000 th->status 1 THREAD_RUNNABLE
0000000000000000000D00000000D

#10 - 06/24/2011 10:29 PM - mame (Yusuke Endoh)
- ruby -v changed from ruby 1.9.2p0 (2010-08-18 revision 29036) [x86_64-darwin10.4.0] to -

goooo
2011060240014:43 KOSAKI Motohiro kosaki.motohiro@jp.fujitsu.com:
00000000000000 thread.stopll process.sleep Dthread.run 0000

0000o0oooooonononononanannononononononaoooon
deadlock check10000000000000000000000

1000000000000000Thread.stop [ deadlock 0000 Kernel#
sleep 00000000000DDO0

Thread.stop 0000000 Thread#run 000000000 (0000
0000000000000000) Okernelttsleep 00000000 ctri-c
(00000000000000000 (0000000oononaoonooan
0000000000000y DooOooOooooaooonoanoog
ruby-dev:35330] 00000000000000000000000

0ooooooooooooooooa

Yusuke Endoh mame@tsg.ne.jp

#11 - 06/24/2011 10:29 PM - mame (Yusuke Endoh)

aoooo

201106024[014:43 KOSAKI Motohiro kosaki.motohiro@jp.fujitsu.com:
00000000000000 thread.stopll process.sleep Dthread.run 0000

000000oooooonononononanannononononononaonoon
deadlock check[10000000000000000000000

1000000000000000Thread.stop [ deadlock 0000 Kernel#
sleep 000000000000DDO0

Thread.stop 00000000 Thread#run 000000000 Q0000
0000000000000000) Okernelitsleep 00000000 ctri-C
(00000000000000000 (0000000oonooaoonooan
0000000000000y booOooaooooooooooaooog
ruby-dev:35330] 00000000000000000000000

0o0ooooooooooooooa

Yusuke Endoh mame@tsg.ne.jp

#12 - 06/24/2011 11:10 PM - nagachika (Tomoyuki Chikanaga)

- File sleep_forever.patch added

RUBY_VM_CHECK_INTS() 000000 th->status 0 THREAD_RUNNABLE 00000000000000

00000 ro_threadptr_check_signal() 000000000000000000 status 00000000000000000000

mth->status = THREAD_RUNNABLE noooooono rb_threadptr_interrupt() 0000000000000000000 status 00000000000000000000D
rb_threadptr_execute_interrupts_rec() 00 th->status 000000000000000000 THREAD_RUNNABLE 0oooooooooo

status [000000000000000000000D0000 rb_threadptr_check_signal() 000000000000000000

000000000DO0000 sleep ODOODDOODOODOODDOODOODD
mailto:kosaki.motohiro@jp.fujitsu.com
https://blade.ruby-lang.org/ruby-dev/35330
#13 - 06/25/2011 09:20 AM - kosaki (Motohiro KOSAKI)
- Status changed from Open to Assigned

- Assignee set to matz (Yukihiro Matsumoto)

kosakilll

unblock functionlGvLOOOOO000000000thread state0000000000000000000000000000000000000000000000O00OKD
00ircOO000000000 mamelOooon

ruby -e 'trap(:INT) { }; sleep’

000sleepl0000000000D0D0DODODO0O0DODODODODD
00obobooooooo

000boboboDopopopooo

00ooo
000000000000000nagachikal000000000000000
000traplsteepl0000000000000000000000O0OODOD

sleepl0000000trap0000000000sIeepd0N0OONN
aooboooooa

goooooooooooooooooooboooOOOODOOOOOOODDD
gooooooooooobooooooooboOOOOODODDDOOOO0DD
gooooooooooo

#14 - 06/25/2011 09:53 AM - kosaki (Motohiro KOSAKI)

aaooon
2011060240014:43 KOSAKI Motohiro kosaki.motohiro@jp.fujitsu.com:
00000000000o0o0 thread.stopﬂ process.sleep 0thread.run 0000

0000o0oooonoDononononanoononononononaonooonoD
deadlock check[10000000000000000000000

100o0000000000000Thread.stop [ deadlock 0000 Kernel#
sleep 000000000000000

Thread.stop 0000000 Thread#run 000000000 (00000
0000000000000000) Okernelitsleep 0000000 ctri-C
(10000000000000000 (000000noononaonoonan
0000000000000y boooooooooooonooaonono
ruby-dev:35330] 100000000000000000000000D

aooooobooooooooooo
00000000000000000000o0nno0no0noanDnanD
0000bopooboooo
00000000 sigpipe 000000O0DO0D0DO0DO0OODOODD
trap(:INT) { } 1000 Ruby000000000000000wakeupl0OOD
DDDDDDDDDDDDDDDDDDDD

000000000000000000000000000unix0000000000
Windows [0 Jruby00O0000000

#15 - 06/25/2011 09:53 AM - kosaki (Motohiro KOSAKI)

0oooo

201106024014:43 KOSAKI Motohiro kosaki.motohiro@ijp.fujitsu.com:
mailto:kosaki.motohiro@jp.fujitsu.com
00000000000000 thread.stopl process.sleep OOthread.run 0000
10000oo00noononoononoOnonoononoanOnoaODonoaD
deadlock check[0000000000000000000000

0000000000000000Thread.stop [ deadlock 0000 Kernel#
sleep 1000000000DOODD

Thread.stop 00000000 Thread#run 000000000 (00000
(000000000DO00000) Okernektsleep OOOOODOD Ctr-C
(000000000000000D (0O000noononoononaon
0000000000000y O00O000O000000o00aoonD
[ruby-dev:35330] 100000000000000000O00DO0

000DoDopoooobonono

0000000000000000000000D0DoDaD000n0Dn0Dg
0000ooooooonono

00000000 sigpipe 000000O00000DO0DO00DOO0DO0OD
trap(:INT) { 3 0000 rubyO000000000000000wakeupdOOO0
q0000o000oonoDoooooa

000000onoDoooonOnoDonOnOnOo0unix0ODODODODO
Windows [0 yrRuby[000000000

#16 - 06/25/2011 10:23 AM - matz (Yukihiro Matsumoto)
aooo oooooo

In message "Re: [ruby-dev:43895] [Ruby 1.9 - Bug #4072][Assigned] dRuby(0000000000000sleepl0000exitD0000"
on Sat, 25 Jun 2011 09:20:27 +0900, Motohiro KOSAKI kosaki.motohiro@gmail.com writes:

\00ircO0000000000 mameOOOO0

|
[ruby -e 'trap(:INT) { }; sleep’

|
\000sleepl00000000000O0DDOODOODOODDOODODDDD
(0000000b00ooog

|
(000000000oo0baonoon

00000000000000000000000O0a0a0g
000000oDoDopoooononoDng

#17 - 06/25/2011 10:23 AM - matz (Yukihiro Matsumoto)
0ooo oooooo

In message "Re: [ruby-dev:43895] [Ruby 1.9 - Bug #4072][Assigned] dRuby(0000000000000sleepl0000exitDO000"
on Sat, 25 Jun 2011 09:20:27 +0900, Motohiro KOSAKI kosaki.motohiro@gmail.com writes:

\00ircO0000000000 mameOOOOO

|
[ruby -e 'trap(:INT) { }; sleep’

|
\000sleepl00000000000O0DDOODOODOODDOODODDDD
(0000000b00ooong

|
(000000000oo0baonoon

00000000000000000000000ananang
000000oDoDopoooononong

#18 - 06/25/2011 11:28 PM - nagachika (Tomoyuki Chikanaga)
- Status changed from Assigned to Closed

- % Done changed from 0 to 100

This issue was solved with changeset r32226.
(0, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.
May Ruby be with you.
e thread.c (sleep_forever): now Kernel#sleep don't wakeup by
signal handler execution. [Bug #4072]

Files

sleep_forever.patch 1.23 KB 06/24/2011 nagachika (Tomoyuki Chikanaga)
